arch snes.cpu

LoROM

//====================================================================
// MAP OF NEW DATA IN EXPANDED ROM AREA
//====================================================================
// 23ffc0-2effe0   NEW GRAPHICS: PALETTE FOR GOLBEZ SUMMON (FOR TSUSHIY ENEMY CHANGER PATCH)
// 26A000-26A3DF   NEW ASM & GRAPHICS: GOLBEZ SUMMON STUFF (FOR TSUSHIY ENEMY CHANGER PATCH)
// 26A3E0-
// 26AB00-26AB3F   NEW GRAPHICS: TILEMAP FOR DREADNOUGHT GRAPHICS WHEN CHASING AIRSHIP
// 288000-28977F   NEW TEXT: ALTERNATE LONG BATTLE ACTION NAMES (FOR TSUSHIY ENEMY CHANGER PATCH)
// 289780-28A0BF   NEW TEXT: ALTERNATE LONG MAGIC SPELL NAMES (FOR TSUSHIY ENEMY CHANGER PATCH)
// 28A0C0-28A29F   NEW TEXT: SHORT MAGIC SPELL NAMES
// 28A2A0-28A47F   NEW TEXT: ALTERNATE SHORT MAGIC SPELL NAMES (FOR TSUSHIY ENEMY CHANGER PATCH)
// 28A480-28ABFF   NEW TEXT: OUTER SPACE LEGEND TEXT (NOT REALLY NEEDED FOR THIS HACK THOUGH)
// 28AC00-28AFFF   EXTRA ASM: ADD CLEAR TIME TO END CREDITS ROLL
// 28B000-28FFFF   NEW ASM & GRAPHICS: INTRO SCREEN STUFF
// 298200-2983FF   ***** DON'T PUT ANYTHING HERE, IT COLLIDES WITH TSUSHIY'S FF2C PATCH!
// 298400-29FFFF   MAIN TEXT, BANK 1a
// 2A8000-2A9FFF   MAIN TEXT, BANK 1b
// 2AC000-2AC23F   TEXT POINTERS: ITEM DESCRIPTIONS
// 2AC240-2AFFFF   TEXT STRINGS: ITEM DESCRIPTIONS
// 2B8000-2BA02F   TEXT STRINGS: LONG ITEM NAMES 
// 2BA030-2BB7AF   TEXT STRINGS: LONG BATTLE ACTION NAMES
// 2BB7B0-2BD3DF   TEXT STRINGS: LONG ENEMY NAMES
// 2BD3E0-2BEFFF   TEXT STRINGS: ALTERNATE ENEMY NAMES (FOR TSUSHIY ENEMY CHANGER PATCH)
// 2BF000-29B29F   NEW ASM: INTRO LEGEND DISPLAY
// 2BF2A0-2BF2FF   TEXT STRINGS: ITEM HANDEDNESS (BATTLE)
// 2BF300-2BF4FF   NEW ASM: MAIN DIALOGUE + WINDOW ENHANCEMENTS
// 2BF500-2BF7FF   NEW ASM: BATTLE TEXT ENHANCEMENTS
// 2BF800-2BFAFF   NEW ASM: MAIN MENU & SUB-MENU ENHANCEMENTS
// 2BFB00-2BFCFF   EXTRA ASM: ADD TREASURE COUNTER TO MAIN MENU & CREDITS
// 2BFD00-2BFDFF   EXTRA ASM: ADD TUTORIAL POSTER TO WAR ROOM
// 2BFE00-2BFECF   GRAPHICS: LOCATION NAME WINDOW
// 2BFED0-2BFF9F   GRAPHICS: MONEY HELD WINDOW (AT INNS)
// 2BFFA0-2BFFFF   GRAPHICS: WAR ROOM POSTER ON WALL (2 3BPP TILES)
// 2C8000-2C8FFF   MAIN TEXT, BANK 2a
// 2D8000-2D8FFF   MAIN TEXT, BANK 2b
// 2E8000-2E811F   TEXT STRINGS: LONG CHARACTER CLASS NAMES  
// 2E8120-2E823F   TEXT STRINGS: EXPANDED BATTLE COMMAND MENU NAMES
// 2E8240-2E88FF   TEXT STRINGS: MAP LOCATION NAMES
// 2E8900-2E922F   TEXT STRINGS: LONG MAGIC SPELL NAMES
// 2E9300-2E937F   TEXT POINTERS: STATUS AILMENTS
// 2E9380-2E949F   TEXT STRINGS: STATUS AILMENTS
// 2E94A0-2E955F   TEXT POINTERS: BATTLE NOTICES
// 2e9560-2E99FF   TEXT STRINGS: BATTLE NOTICES
// 2e9a00-2e9bbf   TEXT POINTERS: BATTLE DIALOGUE
// 2E9BC0-2EA5FF   TEXT STRINGS: BATTLE DIALOGUE
// 2EA600-2EAC00   ***** DON'T PUT ANYTHING HERE, IT COLLIDES WITH TSUSHIY'S FF2C PATCH!
// 2EAD00-2EFFFF   MAIN TEXT, BANK 2c
// 2F8000-2F81FF   MENU TEXT POINTERS
// 2F8200-2F9FFF   MENU TEXT STRINGS & LAYOUT DATA
// 2FA000-29EFFF   MAIN TEXT, BANK 3
// 2FF600-2FFFFF   CREDITS TEXT




//====================================================================
// INSERT NEW FONT
//====================================================================

org $AF010
incbin bin/graphics-english-font.bin




//====================================================================
// INCLUDE EXTERNAL ASM MODIFICATION FILES
//====================================================================

incsrc battle.asm
incsrc legend.asm
incsrc maintext.asm
incsrc menus.asm
incsrc misc.asm

// comment these out and rebuild if you don't want these anymore
incsrc extra-poster.asm
incsrc extra-treasure-counter.asm
incsrc extra-intro-screen.asm




//====================================================================
// OPTIONAL HACKS FOR EASIER DEBUGGING
//====================================================================

//org $3ecb8; db $FF    // greatly increase experience from each enemy
//org $3ece4; db $10    // greatly increase money from each enemy

// This is test code that allows you to enter any specified battle group
//org $8c32
//rep #$20
//lda #$0000   // put the battle group ID here
//sta $1800
//sep #$20
//xba
//lda #$00
//xba
//nop
//nop
//nop