//====================================================================
// MISCELLANEOUS MODIFICATIONS
//====================================================================


//-----------------------------------------------------------------------------
// TITLE SCREEN-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

// Insert "Eng Ver. X.XX" graphics
org $8C000; incbin bin/graphics-ff2re-title-screen-data.bin

//-----------------------------------------------------------------------------
// Modify title screen to say the version number of this translation patch
// move bottom text (which is a bunch of sprites) to center properly
org $88aa; db $5e,$cc
org $88ae; db $66,$cc
org $88b2; db $6e,$cc
org $88b6; db $76,$cc
org $88ba; db $7e,$cc
org $88be; db $86,$cc
org $88c2; db $8e,$cc
org $88c6; db $96,$cc
org $88ca; db $9e,$cc




//-----------------------------------------------------------------------------
// LOCATION NAME-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $2e8240; db "****************NEW TEXT: EXPANDED LOCATION NAMES"

//-----------------------------------------------------------------------------
// allow for longer location names by expanding location names + the window
// the window is built manually (wtf) but nice and easy to edit at least
// b90e area is where stuff happens

// move window left
org $b95b; db $42 
org $b979; db $62
org $b9b1; db $82
org $b9ee; db $a2

// expand top border
org $2BFE00; db "****************NEW GRAPHICS: EXPANDED LOCATION WINDOW"
org $2BFE40; incbin bin/window-location.bin
org $b963; lda $2bfe40,x 
org $b96b; lda $2bfe40,x
org $b974; db $38

// expand bottom border
org $b9f6; lda $2bfe90,x 
org $b9fe; lda $2bfe90,x
org $ba07; db $38

// move right border to the right spot
org $b99f; db $7d
org $b9d7; db $9d

// fill the window with spaces
org $b99a; db $1a  
org $b9d2; db $1a
org $b987; nop; nop; nop;
org $b9a7; nop; nop; nop;
org $b9bf; nop; nop; nop;
org $b9df; nop; nop; nop;

// allow longer names
org $b8f1; lda $2e8280,x
org $b901; lda $2e8280,x
org $b92c; lda $2e8280,x
org $b90f; db $1a
org $b923; db $1a

// relocate where the location text is temporarily stored in RAM to allow for longer lengths
org $b91b; sta $0754,x; sta $0774,x
org $b934; sta $0754,y; xba; sta $0774,y
org $b98d; lda $0774,x
org $b9c5; lda $0754,x




//-----------------------------------------------------------------------------
// INN MONEY WINDOW EXPANSION-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $2bfed0; db "****************NEW GRAPHICS: INN MONEY WINDOW"

org $2bff00; incbin bin/window-inn-price.bin
org $ad29; db $2b    // set bank where our new window data is stored
org $ad2e; dw $ff00  // first row data offset
org $ad3a; dw $001c  // first row data length
org $ad34; dw $2890  // first row target

org $ad4c; dw $ff20  // second row data offset
org $ad52; dw $001c  // second row data length
org $ad43; dw $28b0  // second row target

org $ad64; dw $ff40  // third row data offset
org $ad6a; dw $001c  // third row data length
org $ad5b; dw $28d0  // this row target

org $ad7c; dw $ff60  // fourth row data offset
org $ad82; dw $001c  // fourth row data length
org $ad73; dw $28f0  // fourth row target

org $ad8b; dw $28d1  // move Gil number left

// replace the main dialogue "yes/no" choice box with our own
// same size & stored in same place as original
org $14f656; incbin bin/window-yes-no.bin




//-----------------------------------------------------------------------------
// OUTER SPACE LEGEND TEXT-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------
// Note: we don't need to deal with the outer space legend text in FFC2 hack
// but I thought I'd expand it anyway for others' future use in other projects

org $28A480; db "****************NEW TEXT: OUTER SPACE LEGEND TEXT"
org $13d81f; db $28      // tell the game where to find the new legend text
org $13d819; dw $a4c0




//-----------------------------------------------------------------------------
// CREDITS-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $2FF600
db "****************NEW TEXT: ENGLISH CREDITS"

//-----------------------------------------------------------------------------
// Modify the credits to load from our custom expanded location
org $13d7f0; dw $F630
org $13d7f6; db $2F

//-----------------------------------------------------------------------------
// Shortens the length of the credits roll, since we don't have many to show
// Note that this number isn't very accurate or intuitive, and I'm not sure how
// it works exactly.
org $13d69e; dw $0018

//-----------------------------------------------------------------------------
// Change the song that plays during the credits roll
org $12a1f0; db $35    // credits song
org $13efda; db $35    // song when "THE END" appears

//-----------------------------------------------------------------------------
// Move the "THE END" graphics to a different spot in VRAM so the standard
// character set doesn't get trampled on
org $13D741; dw $0400   // move VRAM target location
org $13eed4; db $10     // change top tile layout to use new VRAM location
org $13eed8; db $1c     // change bottom tile layout to use new VRAM location




//-----------------------------------------------------------------------------
// FF2C-SPECIFIC GAME FIXES AND MODIFICATIONS
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Makes the Kashuan Blade actually equippable
// For some reason, this item got messed up between the two Japanese versions.
// In short, in our remake translation, the Kashuan Blade now only acts like
// the "Spoon/Kitchen Knife" item from FF4, but was meant to be equippable by
// Gordon.
//
// Supposedly you could take the Great Mythril sword (Gordon gets it when he
// becomes a Paladin) to Kokkol and he'd forge it into the Kashuan Blade, but
// I can't get that event to happen. I accidentally got it to happen once, but
// now I have no idea how to make it happen again. I suspect it, too, got
// broken/undone between the Japanese patch versions.
//
// In any case, you can still win the Kashuan Blade from Shinryu as a random
// drop. I hope someone can figure out this weird event stuff someday though.

// Alters the Kashuan Blade item data to match what was originally intended
// Unfortunately it also allows Firion to equip it, but that's no big deal
// at the moment I guess.
org $f92f0; db $80,$64
org $f92f4; db $05,$88,$1c




//-----------------------------------------------------------------------------
// Changes warp location after Leon meets Hilda post-Palamecia Castle
//
// In the original Japanese patch, you get thrown into Baron city's entrance.
// But if you don't talk to Cid, you'll still be able to get the airship
// and take it underground. But the airship won't be able to go over lava,
// which could get some people stuck, and the solution isn't obvious.
//
// To help avoid this, these tiny changes instead warp us straight in front
// of Cid's house (technically Paul's house) so that players are far more
// likely to continue the series of events as needed & intended.
//
// I originally tried to warp the party directly into the house, but leaving
// the house would take you back to the throne room, where the previous map
// was. So this seemed to be the easiest solution. If anyone can fix this,
// please do!

org $12984b; db $00,$06,$0c   // puts player on Map 0 at the given coords


//-----------------------------------------------------------------------------
// Hide various secret entrances from FFIV that no longer function

// hide the secret wall outline in Poft pub/bar/wherever Cid hangs out
org $179fec; db $40,$43
org $179ffd; db $40,$40

// hide the secret wall outline in Dwarf Castle next to Fat Chocobo
org $18faf2; db $2b,$2c
org $18fb05; db $2d,$2e

// hide the secret wall outline in Dwarf Castle throne room
org $18f9e3; db $44,$40
org $18f9f6; db $40,$40




//-----------------------------------------------------------------------------
// make it impossible to miss the shortcut tile trigger in the final room of
// the underground waterway
org $17f186; db $77   // put an empty chest in the way




//-----------------------------------------------------------------------------
// After Gordon becomes a paladin in Kashuan Keep, and just as you leave the
// peninsula the castle is on, a cut scene  shows Cid and the princess being
// chased by the Dreadnought. Except it's just the same scene from FF4 when the
// Red Wings are chasing the Falcon, which is just two airship and not the
// Dreadnought/Whale chasing an airship. I've manually replaced the program
// code that displays the pursuing airship sprite with code that displays the
// Dreadnought instead. This clearly doesn't belong in a standard FF4 hack, so
// take this out if you're using these files/tools for something else!

org $de3f; db $30    // move the pursuing ship a little left
org $de47; dw $0000  // move the sprite data to the start of OAM for more breathing room

org $26AB00; incbin bin/graphics-dreadnought-tilemap.bin
org $dfd1; fill $43,$ea
org $dfd1
jsl make_dreadnought_chase_cid
rts




//====================================================================
// EXPANDED AREA CODE GOES HERE
//====================================================================

org $28AC00
db "****************NEW CODE: DISPLAY CLEAR TIME IN CREDITS"

//-----------------------------------------------------------------------------
// Most of this code is basically a copy of what's used in the original game
// coding to print the current play time on the main menu

display_clear_time_in_credits:
sep #$20
lda $16a4
sta $73
ldx $16a5
stx $74

jsl dctic_conv1
jsl dctic_conv1
ldx $73
bcc +
ldy #$12ed
jsl dctic_conv2
lda $5b
sta $92eb    // still not 100% sure what this could be, thousands of hours?
rtl

//-----------------------------------------------------------------------------

+
ldy $29

dctic_conv2:
lda $1d
jsl dctic_conv3
cmp #$ff
bne +
lda #$90

+
sta $92f0
xba
sta $92f1
rep #$20
lda $73

sep #$20
jsl dctic_conv4
lda $5b
sta $92ec
lda $5d
sta $92ed
lda $5e
sta $92ee
lda #$c8
sta $92ef
rtl

//-----------------------------------------------------------------------------
dctic_conv1:
stz $1d
ldx #$0018
rol $73
rol $74
rol $75

-
rol $1d
lda $1d
cmp #$3c
bcc +
sbc #$3c
sta $1d

+
rol $73
rol $74
rol $75
dex
bne -
rtl

//-----------------------------------------------------------------------------
dctic_conv3:
stz $45
-
sec
sbc #$0a
bcc +
inc $45
bra -

+
adc #$8a
xba
lda $45
bne +
lda #$ff
rtl

+
clc
adc #$80
rtl

//-----------------------------------------------------------------------------
dctic_conv4:
phx
phy
rep #$20
ldx #$007f
stx $5a

-
inc $5a
sec
sbc #$03e8
bpl -

clc
adc #$03e8
phd
ldx #$4200
phx
pld
sta $04
sep #$20
lda #$64
sta $06
jsl dctic_conv5
lda $14
clc
adc #$80
sta $00005b
lda $16
sta $04
tdc
sta $05
lda #$0a
sta $06
jsl dctic_conv5
lda $14
clc
adc #$80
sta $00005d
lda $16
pld

clc
adc #$80
sta $5e
lda $5a
cmp #$80
bne +

lda #$ff
sta $5a
lda $5b
cmp #$80
bne +

lda #$ff
sta $5b
lda $5d
cmp #$80
bne +

lda #$ff
sta $5d

+
ply
plx
rtl

//-----------------------------------------------------------------------------
dctic_conv5:
nop
nop
nop
nop
nop
nop
rtl


make_dreadnought_chase_cid:

ldx #$0000
ldy #$0000
//stz $752    // this will be our loop counter

-

lda $26ab00,x
clc
adc $0c
sec
sbc #$0c
sta $300,x

// in the original code at $dfb6 there's a coordinate check + conditional jsl
// but I don't care cause it doesn't apply to FF2c

lda $26ab01,x
clc
adc $0e
sec
sbc #$30
sta $301,x

lda $26ab02,x
sta $302,x
lda $26ab03,x
sta $303,x

inx
inx
inx
inx
iny
cpy #$0010
bcc -

rtl




